<script src="./Script.js"></script>

<template>
  <div
    data-backdrop="static"
    data-keyboard="false"
    class="modal s--modal s--modal-right animated fadeInRight"
    id="addNewIndividualCustomer"
  >
    <div class="modal-dialog" style="max-width: 450px;">
      <div class="modal-content">
        <div class="modal-header">
          <h3 class="modal-title">Thêm khách hàng cá nhân</h3>
          <button
            type="button"
            class="close modal-close"
            data-dismiss="modal"
            aria-label="Close"
            @click.prevent="reset()"
          >
            <span aria-hidden="true">
              <i class="la la-times"></i>
            </span>
          </button>
        </div>

        <div class="modal-body" data-scrollable="true" data-scrollbar-shown="true">
          <form class="m-form m-form--state">
            <div class="row">
              <div class="col-md-12">
                <div
                  class="s--alert m-alert m-alert--outline alert alert-success text-center"
                  v-if="isSuccess"
                >
                  <div class="s--alert-icon">
                    <i class="la la-check"></i>
                  </div>
                  <div class="s--alert-message">
                    <h5 class="s--alert-heading">Thêm mới khách hàng thành công.</h5>
                    <router-link
                      target="_blank"
                      class="m-link m-link--primary nt-link"
                      :to="{name : 'customerDetails', params : {team_id : currentTeam.team_id, customer_id : customerId} }"
                    >Xem chi tiết khách hàng</router-link>
                  </div>
                </div>
                <div
                  class="s--alert m-alert m-alert--outline alert alert-danger text-center"
                  v-if="messageErrorServer"
                >
                  <div class="s--alert-icon">
                    <i class="la la-close"></i>
                  </div>
                  <div class="s--alert-message">
                    <h5 class="s--alert-heading">{{ messageErrorServer }}</h5>
                  </div>
                </div>
              </div>

              <div class="col-md-12">
                <!--<h5 style="font-size: 15px">Thông tin khách hàng</h5>-->

                <div
                  class="form-group m-form__group"
                  v-for="( attribute, index ) in listAttributeCodesByAllAttributes"
                  :key="index"
                  :class="{ 'has-danger': errors.has('createNewIndividualCustomer.' + attribute.attribute_code) || attribute.data_type.id == 5 && emailIsExists && customer.attributes[index].attribute_value || attribute.data_type.id == 4 && phoneIsExists && customer.attributes[index].attribute_value || server_errors != '' && server_errors[attribute.attribute_code]}"
                >
                  <template v-if="customer.attributes[index]">
                    <label :for="attribute.attribute_code" class="form-control-label s--label">
                      {{
                      attribute.attribute_name }}
                      <span
                        class="m--font-danger"
                        v-if="attribute.is_required"
                      >*</span>
                    </label>

                    <s-input-text
                      data-vv-scope="createNewIndividualCustomer"
                      v-if="attribute.data_type && attribute.data_type.id == 1"
                      v-model="customer.attributes[index].attribute_value"
                      v-validate="{ required: attribute.is_required ? true : false, max: 250 }"
                      :id="attribute.attribute_code"
                      :name="attribute.attribute_code"
                    ></s-input-text>

                    <s-input-phone
                      data-vv-scope="createNewIndividualCustomer"
                      v-if="attribute.data_type && attribute.data_type.id == 4"
                      v-model="customer.attributes[index].attribute_value"
                      v-validate="{ regex: helpers.regexPhone() }"
                      :id="attribute.attribute_code"
                      :name="attribute.attribute_code"
                      v-on:keyup="checkPhoneExists(customer.attributes[index].id, customer.attributes[index].attribute_value)"
                    ></s-input-phone>

                    <s-input-email
                      data-vv-scope="createNewIndividualCustomer"
                      v-if="attribute.data_type && attribute.data_type.id == 5"
                      v-model="customer.attributes[index].attribute_value"
                      v-validate="{  regex: helpers.regexEmail(),  max: 250 }"
                      :id="attribute.attribute_code"
                      :name="attribute.attribute_code"
                      v-on:keyup="checkEmailExists(customer.attributes[index].id, customer.attributes[index].attribute_value)"
                    ></s-input-email>

                    <div
                      class="form-control-feedback m--font-danger"
                      v-if="server_errors != '' && server_errors[attribute.attribute_code]"
                    >
                      <template
                        v-if="server_errors[attribute.attribute_code].exist"
                      >{{ attribute.attribute_name }} bị trùng.</template>
                      <template v-else>{{ server_errors[attribute.attribute_code][0] }}</template>
                    </div>

                    <div
                      class="form-control-feedback m--font-danger"
                      v-else-if="errors.has('createNewIndividualCustomer.' + attribute.attribute_code)"
                    >
                      <div v-for="(error, indexA) in errors.items" :key="indexA">
                        <template v-if="errors.items && errors.items.length > 0">
                          <template
                            v-if="attribute.attribute_code == error.field && error.rule == 'required'"
                          >Không được để trống trường này.</template>
                          <template
                            v-if="attribute.attribute_code == error.field && error.rule == 'max' && error.scope == 'createNewIndividualCustomer'"
                          >Giới hạn 250 ký tự.</template>

                          <template
                            v-if="attribute.attribute_code == error.field && error.rule == 'regex' && error.scope == 'createNewIndividualCustomer'"
                          >
                            Định dạng
                            <span class="text-lowercase">{{ attribute.attribute_name }}</span> không đúng.
                          </template>
                        </template>
                      </div>
                    </div>

                    <div class="form-control-feedback m--font-danger" v-else>
                      <template
                        v-if="customer.attributes[index].attribute_value && attribute.data_type.id == 5 && emailIsExists"
                      >{{ attribute.attribute_name }} bị trùng.</template>
                      <template
                        v-if="customer.attributes[index].attribute_value && attribute.data_type.id == 4 && phoneIsExists"
                      >{{ attribute.attribute_name }} bị trùng.</template>
                      <template v-else>&nbsp;</template>
                    </div>
                  </template>
                </div>
              </div>

              <!--<div class="col-md-6">-->
              <!--<template v-if="customer.contacts && customer.contacts.length > 0"-->
              <!--v-for="( contact, index_contact) in customer.contacts">-->
              <!--<h5 style="font-size: 15px">Thông tin người thân #{{ index_contact + 1 }}</h5>-->

              <!--<div class="form-group m-form__group"-->
              <!--:class="{ 'has-danger': errors.has('createNewIndividualCustomer.contact_name' + index_contact) }">-->
              <!--<label :for="'contact_name' + index_contact"-->
              <!--class="form-control-label s&#45;&#45;label">Họ tên</label>-->

              <!--<s-input-text v-model="customer.contacts[index_contact].full_name" type="text"-->
              <!--:id="'contact_name' + index_contact" class="form-control"-->
              <!--:name="'contact_name' + index_contact"-->
              <!--data-vv-scope="createNewIndividualCustomer"-->
              <!--v-validate="{ max: 250, required: customer.contacts[index_contact].phone != '' && !errors.has('createNewIndividualCustomer.contact_phone' + index_contact) || customer.contacts[index_contact].email != '' && !errors.has('createNewIndividualCustomer.contact_email' + index_contact) ? true : false, }"></s-input-text>-->

              <!--<div class="form-control-feedback m&#45;&#45;font-danger"-->
              <!--v-if="errors.has('createNewIndividualCustomer.contact_name' + index_contact)">-->
              <!--{{ errors.first('createNewIndividualCustomer.contact_name' + index_contact)-->
              <!--}}-->
              <!--</div>-->
              <!--<div class="form-control-feedback m&#45;&#45;font-danger" v-else>&nbsp;</div>-->
              <!--</div>-->

              <!--<div class="form-group m-form__group"-->
              <!--:class="{ 'has-danger': errors.has('createNewIndividualCustomer.contact_phone' + index_contact) }">-->
              <!--<label :for="'contact_phone' + index_contact"-->
              <!--class="form-control-label s&#45;&#45;label">Số điện thoại</label>-->

              <!--<s-input-phone v-model="customer.contacts[index_contact].phone" type="text"-->
              <!--:id="'contact_phone' + index_contact" class="form-control"-->
              <!--:name="'contact_phone' + index_contact"-->
              <!--data-vv-scope="createNewIndividualCustomer"-->
              <!--v-validate="{ regex: helpers.regexPhone() }"></s-input-phone>-->

              <!--<div class="form-control-feedback m&#45;&#45;font-danger"-->
              <!--v-if="errors.has('createNewIndividualCustomer.contact_phone' + index_contact )">-->
              <!--{{ errors.first('createNewIndividualCustomer.contact_phone' + index_contact)-->
              <!--}}-->
              <!--</div>-->
              <!--<div class="form-control-feedback m&#45;&#45;font-danger" v-else>&nbsp;</div>-->
              <!--</div>-->

              <!--<div class="form-group m-form__group"-->
              <!--:class="{ 'has-danger': errors.has('createNewIndividualCustomer.contact_email' + index_contact) }">-->
              <!--<label :for="'contact_email' + index_contact"-->
              <!--class="form-control-label s&#45;&#45;label">Email</label>-->

              <!--<s-input-email v-model="customer.contacts[index_contact].email" type="text"-->
              <!--:id="'contact_email' + index_contact" class="form-control"-->
              <!--:name="'contact_email' + index_contact"-->
              <!--data-vv-scope="createNewIndividualCustomer"-->
              <!--v-validate="{ regex: helpers.regexEmail(), max: 250 }"></s-input-email>-->

              <!--<div class="form-control-feedback m&#45;&#45;font-danger"-->
              <!--v-if="errors.has('createNewIndividualCustomer.contact_email' + index_contact)">-->
              <!--{{ errors.first('createNewIndividualCustomer.contact_email' + index_contact)-->
              <!--}}-->
              <!--</div>-->
              <!--<div class="form-control-feedback m&#45;&#45;font-danger" v-else>&nbsp;</div>-->
              <!--</div>-->
              <!--</template>-->
              <!--</div>-->
            </div>
          </form>
        </div>

        <div class="modal-footer">
          <button
            @click.prevent="reset()"
            type="button"
            class="btn btn-link mr-2 m-btn--custom modal-close"
            data-dismiss="modal"
          >Hủy bỏ</button>
          <button
            @click.prevent="createNewIndividualCustomer('createNewIndividualCustomer')"
            :disabled="errors.any() ||  helpers.getAttributeByAttrCodeAndVariableName(customer, 'email', 'attribute_value') && emailIsExists || helpers.getAttributeByAttrCodeAndVariableName(customer, 'phone', 'attribute_value') && phoneIsExists || isLoader || isLoaderCheckExists"
            :class="{'s--btn_disabled' : errors.any() || helpers.getAttributeByAttrCodeAndVariableName(customer, 'email', 'attribute_value') && emailIsExists || helpers.getAttributeByAttrCodeAndVariableName(customer, 'phone', 'attribute_value') && phoneIsExists || isLoader}"
            type="submit"
            class="btn btn-primary m-btn m-btn--custom"
          >Lưu lại</button>
        </div>
      </div>
    </div>
  </div>
</template>
